//
// IFelica.aidl
//
// Copyright 2009 FeliCa Networks, Inc.
// All Rights Reserved.
// FeliCa Networks, Inc. Proprietary/Confidential.
//
package com.felicanetworks.mfc;

import com.felicanetworks.mfc.IFelicaEventListener;
import com.felicanetworks.mfc.IFelicaPushAppNotificationListener;
import com.felicanetworks.mfc.DataList;
import com.felicanetworks.mfc.BlockList;
import com.felicanetworks.mfc.BlockDataList;
import com.felicanetworks.mfc.PushSegment;
import com.felicanetworks.mfc.PushSegmentParcelableWrapper;
import com.felicanetworks.mfc.PrivacySettingData;
import com.felicanetworks.mfc.FelicaResultInfo;
import com.felicanetworks.mfc.FelicaResultInfoBoolean;
import com.felicanetworks.mfc.FelicaResultInfoInt;
import com.felicanetworks.mfc.FelicaResultInfoByteArray;
import com.felicanetworks.mfc.FelicaResultInfoIntArray;
import com.felicanetworks.mfc.FelicaResultInfoBlockCountInformationArray;
import com.felicanetworks.mfc.FelicaResultInfoDataArray;
import com.felicanetworks.mfc.FelicaResultInfoNodeInformation;

/**
 * FeliCa APIs邽߂AIDLC^[tF[XłB
 * <p>
 */
interface IFelica {

    /**
     * FeliCa`bv̗pJn{܂B<p>
     * permitListɂnullݒ肷邱Ƃ\łB
     * <p>
     * @param permitList ؃Xg
     * @param listener ʒʒmpXi
     * <p>
     * @return OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_SECURITY} ANZXȂꍇ
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_ILLEGAL_ARGUMENT} ʒʒmpXinull̏ꍇ
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} pJnsꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_USED_BY_OTHER_APP}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_ALREADY_ACTIVATED}</td>
     * </tr>
     * </tbody> </table>
     * ʂ{@link FelicaException#ID_ILLEGAL_STATE_ERROR}Ń^Cv{@link FelicaException#TYPE_USED_BY_OTHER_APP}̏ꍇ
     * {@link FelicaResultInfo#getOtherAppPID}Felicap̃vZXID擾ł܂B
     */
    FelicaResultInfo activateFelica(in String[] permitList , IFelicaEventListener listener);

    /**
     * FeliCa`bvN[Y܂B`bv̓d̓ItɂȂ܂BɃN[YĂꍇ͉s܂B
     * <p>
     * <code>FSC</code>
     * FeliCaT[oƂ̃ICsĂԂɂ̃\bhĂ΂ꂽꍇAFeliCaT[oɉʒm邱ƂȂI܂B
     * <p>
     * {@link #setPushNotificationListener}Őݒ肵PushAvʒmXiyуAvP[VʃR[hNA܂B
     * <p>
     * @return OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} N[Ysꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfo close();

    /**
     * w肵GA܂̓T[rX̃ubNgp󋵁i蓖ăubNы󂫃ubNjFeliCa`bv擾܂B
     * <p>
     * @param nodeCodeList GA܂̓T[rẌꗗ
     * @param timeout ^CAEgl
     * @param retry gC
     * <p>
     * @return w肵GA܂̓T[rX̃ubNgp
     * <p>
     * OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_ILLEGAL_ARGUMENT} GA܂̓T[rẌꗗ̐Kl͈̔͊OƂȂꍇ
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} 蓖ăubNы󂫃ubN擾łȂꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_SELECTED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_PERMISSION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_ILLEGAL_METHOD_CALL}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_INVALID_RESPONSE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_TIMEOUT_OCCURRED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_GET_BLOCK_COUNT_INFORMATION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_GET_BLOCK_COUNT_INFORMATION_FAILED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_UNKNOWN_ERROR}</td>
     * <td>{@link FelicaException#TYPE_GET_BLOCK_COUNT_INFORMATION_FAILED}</td>
     * </tr>
     * </tbody> </table>
     * <p>
     * ʂ{@link FelicaException#ID_GET_BLOCK_COUNT_INFORMATION_ERROR}̏ꍇ
     * Xe[^XtO`FbN邱ƂɂG[ڍׂ擾ł܂B
    @    */
    FelicaResultInfoBlockCountInformationArray getBlockCountInformation(in int[] nodeCodeList, int timeout, int retry);

    /**
     * FeliCa`bvReiID擾܂B
     * <p>
     * @param timeout ^CAEgl
     * @param retry gC
     * @return ReiID
     * <p>
     * OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} ReiID̎擾łȂꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_SELECTED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_PERMISSION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_ILLEGAL_METHOD_CALL}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_INVALID_RESPONSE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_TIMEOUT_OCCURRED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_UNKNOWN_ERROR}</td>
     * <td>{@link FelicaException#TYPE_GET_CONTAINER_ID_FAILED}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfoByteArray getContainerId(int timeout, int retry);

    /**
     * FeliCa`bṽReis擾܂B
     * <p>
     * @param timeout ^CAEgl
     * @param retry gC
     * @return FeliCa`bṽReis
     * <p>
     * OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} Reis񂪎擾łȂꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_SELECTED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_INVALID_RESPONSE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_TIMEOUT_OCCURRED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_UNKNOWN_ERROR}</td>
     * <td>{@link FelicaException#TYPE_GET_CONTAINER_ISSUE_INFORMATION_FAILED}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfoByteArray getContainerIssueInformation(int timeout, int retry);

    /**
     * ݑIĂVXeICR[h擾܂B
     * <p>
     * @return ݑIĂVXeICR[h
     * <p>
     * OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} ICR[h擾łȂꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_SELECTED}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfoByteArray getICCode();

    /**
     * ݑIĂVXeIDm擾܂B
     * <p>
     * @return ݑIĂVXeIDm
     * <p>
     * OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} IDm擾łȂꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_SELECTED}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfoByteArray getIDm();

    /**
     * FeliCa`bṽVXeIŎgpC^tF[X(LE)擾܂B
     * <p>
     * @return C^tF[X
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;">C^tF[X</th>
     * <th style="text-align: center;">萔</th>
     * </tr>
     * <tr>
     * <td>LC^tF[X</td>
     * <td>{@link Felica#INTERFACE_WIRED}</td>
     * </tr>
     * <tr>
     * <td>C^tF[X</td>
     * <td>{@link Felica#INTERFACE_WIRELESS}</td>
     * </tr>
     * </tbody> </table>
     * <p>
     * OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} C^tF[Xʂ擾łȂꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_SELECTED}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfoInt getInterface();

    /**
     * w肳ꂽT[rXA܂̓GǍo[W擾܂B<code>0xffff</code>(m[hR[hTCY4oCg̏ꍇ<code>0xffffffff</code>)
     * w肳ꂽꍇAݑIĂVXěo[WԂ܂B<p>
     * serviceCodeɂ͋؂Ɋ܂܂m[hR[h͈̔͂w肷邱Ƃł܂B
     * <p>
     * @param serviceCode o[W擾T[rXAGAR[h
     * @param timeout ^CAEgl
     * @param retry gC
     * @return w肳ꂽT[rXAGǍo[W
     * <p>
     * OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_ILLEGAL_ARGUMENT} T[rXAGAR[h̑lȂꍇ
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} T[rXA܂̓GǍo[W擾łȂꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_SELECTED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_PERMISSION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_ILLEGAL_NODECODE}</td>
     * </tr>
     * <tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_INVALID_RESPONSE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_TIMEOUT_OCCURRED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_GET_KEY_VERSION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_SERVICE_NOT_FOUND}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_UNKNOWN_ERROR}</td>
     * <td>{@link FelicaException#TYPE_GET_KEY_VERSION_FAILED}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfoInt getKeyVersion(int serviceCode, int timeout, int retry);

    /**
     * w肵GAȉ̊Kw̃m[h̏iGAR[h/GhT[rXR[ḧꗗуT[rXR[ḧꗗjFeliCa`bv擾܂B
     * <p>
     * @param parentAreaCode eGAR[h
     * @param timeout ^CAEgl
     * @param retry gC
     * <p>
     * @return w肵GAȉ̊Kw̃m[h̏
     * <p>
     * OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_ILLEGAL_ARGUMENT} T[rXAGAR[hȂꍇ
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} m[h̏񂪎擾łȂꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_SELECTED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_PERMISSION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_ILLEGAL_METHOD_CALL}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_GET_NODE_INFORMATION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_SERVICE_NOT_FOUND }</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_GET_NODE_INFORMATION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_GET_NODE_INFORMATION_FAILED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_INVALID_RESPONSE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_TIMEOUT_OCCURRED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_UNKNOWN_ERROR}</td>
     * <td>{@link FelicaException#TYPE_GET_NODE_INFORMATION_FAILED}</td>
     * </tr>
     * </tbody> </table>
     * <p>
     * ʂ{@link FelicaException#ID_GET_NODE_INFORMATION_ERROR}̏ꍇ
     * Xe[^XtO`FbN邱ƂɂG[ڍׂ擾ł܂B
     */
    FelicaResultInfoNodeInformation getNodeInformation(int parentAreaCode, int timeout, int retry);

    /**
     * w肵GAȉ̊Kw̃vCoVݒ肪Lȃm[h̏iGAR[h/GhT[rXR[ḧꗗуT[rXR[ḧꗗjFeliCa`bv擾܂B<p>
     * parentAreaCodeɂ͋؂Ɋ܂܂m[hR[h͈̔͂w肷邱Ƃł܂B
     * <p>
     * @param timeout ^CAEgl
     * @param retry gC
     * @param parentAreaCode eGAR[h
     * <p>
     * @return w肵GAȉ̊Kw̃vCoVݒ肪Lȃm[h̏
     * <p>
     * OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_ILLEGAL_ARGUMENT} ؂ɐݒ肳ĂȂGAR[hw肵ꍇ܂̓GAR[hł͂Ȃꍇ
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} vCoVݒ肪Lȃm[h̏񂪎擾łȂꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_SELECTED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_GET_PRIVACY_NODE_INFORMATION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_SERVICE_NOT_FOUND }</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_GET_PRIVACY_NODE_INFORMATION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_GET_PRIVACY_NODE_INFORMATION_FAILED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_INVALID_RESPONSE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_TIMEOUT_OCCURRED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_PERMISSION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_ILLEGAL_METHOD_CALL}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_PERMISSION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_ILLEGAL_NODECODE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_UNKNOWN_ERROR}</td>
     * <td>{@link FelicaException#TYPE_GET_PRIVACY_NODE_INFORMATION_FAILED}</td>
     * </tr>
     * </tbody> </table>
     * <p>
     * ʂ{@link FelicaException#ID_GET_PRIVACY_NODE_INFORMATION_ERROR}̏ꍇ
     * Xe[^XtO`FbN邱ƂɂG[ڍׂ擾ł܂B
     */
    FelicaResultInfoNodeInformation getPrivacyNodeInformation(int parentAreaCode, int timeout, int retry);

    /**
     * RFS[q̏Ԃ擾܂B
     * <p>
     * @return RFS[q̏ԁitrue: High / false: Lowj
     * <p>
     * OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} RFS[q̏Ԏ擾łȂꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfoBoolean getRFSState();

    /**
     * ݑIĂVXẽVXeR[h擾܂B
     * <p>
     * @return ݑIĂVXẽVXeR[h
     * <p>
     * OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} VXeR[h擾łȂꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_SELECTED}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfoInt getSystemCode();

    /**
     * FeliCa`bvVXeR[ḧꗗ擾܂B
     * <p>
     * @param timeout ^CAEgl
     * @param retry gC
     * @return VXeR[ḧꗗ
     * <p>
     * OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} VXeR[ḧꗗ擾łȂꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_SELECTED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_PERMISSION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_ILLEGAL_METHOD_CALL}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_INVALID_RESPONSE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_TIMEOUT_OCCURRED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_UNKNOWN_ERROR}</td>
     * <td>{@link FelicaException#TYPE_GET_SYSTEM_CODE_LIST_FAILED}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfoIntArray getSystemCodeList(int timeout, int retry);

    /**
     * FeliCa`bv̗pI{܂B
     * <p>
     * <p>
     * @return OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} pIsꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_CLOSED}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfo inactivateFelica();

    /**
     * FeliCa`bvI[v܂B`bv̓dIɂȂ܂B ɃI[vĂꍇ͉s܂B
     * I[ṽm[hR[hTCY2oCgi{@link #NODECODESIZE_2}jłB
     * <p>
     * @return OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} I[vsꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_UNKNOWN_ERROR}</td>
     * <td>{@link FelicaException#TYPE_OPEN_FAILED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_INVALID_RESPONSE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_TIMEOUT_OCCURRED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_OPEN_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_IC_CHIP_FORMATTING}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_OPEN_ERROR}</td>
     * <td>{@link FelicaException#TYPE_FELICA_NOT_AVAILABLE}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfo open();

    /**
     * Pushɂf[^Ms܂B
     * <p>
     * @param timeout ^CAEgl
     * @return OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_ILLEGAL_ARGUMENT} Mf[^̃TCY192byte𒴂ꍇ
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} MɎsꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_INVALID_RESPONSE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_TIMEOUT_OCCURRED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_UNKNOWN_ERROR}</td>
     * <td>{@link FelicaException#TYPE_PUSH_FAILED}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfo push(in PushSegmentParcelableWrapper pushSegmentParcelableWrapper);

    /**
     * w肳ꂽubNXggpăubNf[^ǂݍ݂܂B<p>
     * blockListɂ͋؂Ɋ܂܂m[hR[h͈̔͂w肷邱Ƃł܂B
     * <p>
     * @param blockList ǂݍ݂ɎgpubNXg
     * @param timeout ^CAEgl()
     * @param retry gC
     * @return w肳ꂽubNXgɑΉubNf[^̃Xg
     * <p>
     * OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_ILLEGAL_ARGUMENT} ubNXg <code>null</code> A܂͋̏ꍇ
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} ubNf[^ǂݍ߂Ȃꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_SELECTED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_PERMISSION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_ILLEGAL_NODECODE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_INVALID_RESPONSE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_TIMEOUT_OCCURRED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_READ_ERROR}</td>
     * <td>{@link FelicaException#TYPE_SERVICE_NOT_FOUND}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_READ_ERROR}</td>
     * <td>{@link FelicaException#TYPE_BLOCK_NOT_FOUND}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_READ_ERROR}</td>
     * <td>{@link FelicaException#TYPE_PIN_NOT_CHECKED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_READ_ERROR}</td>
     * <td>{@link FelicaException#TYPE_READ_FAILED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_UNKNOWN_ERROR}</td>
     * <td>{@link FelicaException#TYPE_READ_FAILED}</td>
     * </tr>
     * </tbody> </table>
     * <p>
     * ʂ{@link FelicaException#ID_READ_ERROR}̏ꍇ
     * Xe[^XtO`FbN邱ƂɂG[ڍׂ擾ł܂B
     * <p>
     * C^tF[XIAʂ{@link FelicaException#ID_READ_ERROR}̏ꍇ́A
     * ^Cv{@link FelicaException#TYPE_READ_FAILED}ŒƂȂ܂B
     */
    FelicaResultInfoDataArray read(in BlockList blockList,in int timeout,in int retry);

    /**
     * FeliCa`bv\tgEFAZbg܂B
     * goĂ鎞͒~܂B
     * VXeIɂȂ܂B
     * m[hR[hTCY2oCgi{@link #NODECODESIZE_2}jɖ߂܂B
     * <p>
     * @return OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} FeliCa`bṽZbgsꍇ
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_INVALID_RESPONSE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_PERMISSION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_ILLEGAL_METHOD_CALL}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_TIMEOUT_OCCURRED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_UNKNOWN_ERROR}</td>
     * <td>{@link FelicaException#TYPE_RESET_FAILED}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfo reset();

    /**
     * LC^tF[XgpFeliCa`bṽVXeI܂B
     * <p>
     * VXeR[hɂ̓ChJ[h( <code>0xffff, 0x00ff, 0xff00</code> )w肷邱Ƃł܂B
     *
     * @param systemCode VXeR[h
     * @param timeout ^CAEgl
     * @param retry gC
     * @return OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_ILLEGAL_ARGUMENT} VXeR[h͈͊Ȍꍇ(
     *             <code>systemCode < 0x0000 || systemCode > 0xffff</code>)
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} FeliCa`bṽVXeIłȂꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_PERMISSION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_ILLEGAL_METHOD_CALL}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_INVALID_RESPONSE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_TIMEOUT_OCCURRED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_UNKNOWN_ERROR}</td>
     * <td>{@link FelicaException#TYPE_SELECT_FAILED}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfo select(int systemCode);

    /**
     * w肵C^tF[XgpFeliCa`bṽVXeI܂B
     * <p>
     * VXeR[hɂ̓ChJ[h( <code>0xffff, 0x00ff, 0xff00</code> )w肷邱Ƃł܂B
     * <p>
     * @param target C^tF[X
     * @param timeout ^CAEgl
     * @param retry gC
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;">C^tF[X</th>
     * <th style="text-align: center;">萔</th>
     * </tr>
     * <tr>
     * <td>LC^tF[X</td>
     * <td>{@link #INTERFACE_WIRED}</td>
     * </tr>
     * <tr>
     * <td>C^tF[X</td>
     * <td>{@link #INTERFACE_WIRELESS}</td>
     * </tr>
     * </tbody> </table>
     * <p>
     * @param systemCode VXeR[h
     * @return OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_ILLEGAL_ARGUMENT} VXeR[h͈͊Ȍꍇ(
     *             <code>systemCode < 0x0000 || systemCode > 0xffff</code>)A
     *             ܂target{@link #INTERFACE_WIRED}A
     *             {@link #INTERFACE_WIRELESS}̂łȂꍇ
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} FeliCa`bṽVXeIłȂꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_PERMISSION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_ILLEGAL_METHOD_CALL}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_INVALID_RESPONSE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_TIMEOUT_OCCURRED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_UNKNOWN_ERROR}</td>
     * <td>{@link FelicaException#TYPE_SELECT_FAILED}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfo selectWithTarget(int target, int systemCode);

    /**
     * CEN[q𐧌䂵܂B
     * FeliCa`bvN[YԂ̂ݎs\łB
     * <p>
     * @param state CEN[qɐݒ肷ԁitrue: High / false: Lowj
     * <p>
     * @return OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} CEN[q̐䂪łȂꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_CLOSED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_PERMISSION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_ILLEGAL_METHOD_CALL}</td>
     * </tr>
     * </tbody> </table>
     */
//    FelicaResultInfo setCENState(boolean state);

    /**
     * m[h̃vCoVݒύX܂B
     * <p>
     * @param privacySettingData m[h̃vCoVݒ̈ꗗ
     * @param timeout ^CAEgl
     * @param retry gC
     * <p>
     * @return OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_ILLEGAL_ARGUMENT} m[h̐Kl͈̔͊OƂȂꍇ
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} vCoVݒłȂꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_SELECTED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_SET_PRIVACY_ERROR}</td>
     * <td>{@link FelicaException#TYPE_SERVICE_NOT_FOUND }</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_SET_PRIVACY_ERROR}</td>
     * <td>{@link FelicaException#TYPE_SET_PRIVACY_FAILED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_INVALID_RESPONSE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_TIMEOUT_OCCURRED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_PERMISSION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_ILLEGAL_METHOD_CALL}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_UNKNOWN_ERROR}</td>
     * <td>{@link FelicaException#TYPE_SET_PRIVACY_FAILED}</td>
     * </tr>
     * </tbody> </table>
     * <p>
     * ʂ{@link FelicaException#ID_SET_PRIVACY_ERROR}̏ꍇ
     * Xe[^XtO`FbN邱ƂɂG[ڍׂ擾ł܂B
     */
    FelicaResultInfo setPrivacy(in PrivacySettingData[] privacySettingData, int timeout, int retry);

    /**
     * w肳ꂽubNf[^XggpăubNf[^݂܂B<p>
     * blockDataListɂ͋؂Ɋ܂܂m[hR[h͈̔͂w肷邱Ƃł܂B
     * <p>
     * @param blockDataList ݂ɎgpubNf[^Xg
     * @param timeout ^CAEgl
     * @param retry gC
     * @return OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_ILLEGAL_ARGUMENT} ubNf[^Xg <code>null</code> A܂͋̏ꍇ
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} ubNf[^߂Ȃꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_SELECTED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_PERMISSION_ERROR}</td>
     * <td>{@link FelicaException#TYPE_ILLEGAL_NODECODE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_INVALID_RESPONSE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_TIMEOUT_OCCURRED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_WRITE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_PURSE_FAILED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_WRITE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CASH_BACK_FAILED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_WRITE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_INVALID_PIN}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_WRITE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CHECK_PIN_LIMIT}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_WRITE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CHECK_PIN_OVERRUN}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_WRITE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_SERVICE_NOT_FOUND}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_WRITE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_BLOCK_NOT_FOUND}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_WRITE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_PIN_NOT_CHECKED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_WRITE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_ENABLE_PIN_FAILED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_WRITE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_WRITE_FAILED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_UNKNOWN_ERROR}</td>
     * <td>{@link FelicaException#TYPE_WRITE_FAILED}</td>
     * </tr>
     * </tbody> </table>
     * <p>
     * ʂ{@link FelicaException#ID_WRITE_ERROR}̏ꍇ
     * Xe[^XtO`FbN邱ƂɂG[ڍׂ擾ł܂B
     * <p>
     * C^tF[XIAʂ{@link FelicaException#ID_WRITE_ERROR}̏ꍇ́A
     * ^Cv{@link FelicaException#TYPE_WRITE_FAILED}ŒƂȂ܂B
     */
    FelicaResultInfo write(in BlockDataList blockDataList, int timeout, int retry);

    /**
     * PushMɂAvP[Vʒm̃Xiݒ肵܂B
     * <p>
     * Mf[^̃AvP[VʃR[hƐݒ肵AvP[VʃR[hقȂꍇAʒm͍s܂B<p>
     * PushAvʒmXinullw肵ꍇAXi͉܂B
     * @param listener PushAvʒmXi
     * @param appIdentificationCode AvP[VʃR[h
     * @return OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_ILLEGAL_ARGUMENT} PushAvʒmXinullAAvP[VʃR[hnullłȂꍇ
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} Xio^Ɏsꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfo setPushNotificationListener(IFelicaPushAppNotificationListener listener, String appIdentificationCode);

    /**
     * FeliCa`bvɃANZXۂ̃m[hR[h(T[rXAGAR[h)TCYݒ肵܂B
     * <p>
     * @param nodeCodeSize ݒ肷m[hR[hTCY
     * @param timeout ^CAEgl
     * @param retry gC
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;">m[hR[hTCY</th>
     * <th style="text-align: center;">萔</th>
     * </tr>
     * <tr>
     * <td>2oCg</td>
     * <td>{@link #NODECODESIZE_2}</td>
     * </tr>
     * <tr>
     * <td>4oCg</td>
     * <td>{@link #NODECODESIZE_4}</td>
     * </tr>
     * </tbody> </table>
     * @return OAȉ̗OԂ܂BOʂ{@link ResultInfo#getExceptionType}Ŏ擾܂B
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_ILLEGAL_ARGUMENT} m[hR[hTCYsȏꍇ(
     *             {@link #NODECODESIZE_2}A{@link #NODECODESIZE_4}̂łȂꍇ)
     * <p>
     * {@link ResultInfo#EXCEPTION_TYPE_FELICA} m[hR[hTCYݒłȂꍇiڍׂ͉\QƁj
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_SELECTED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_INVALID_RESPONSE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_IO_ERROR}</td>
     * <td>{@link FelicaException#TYPE_TIMEOUT_OCCURRED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_SET_NODECODESIZE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_SET_NODECODESIZE_FAILED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_UNKNOWN_ERROR}</td>
     * <td>{@link FelicaException#TYPE_SET_NODECODESIZE_FAILED}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfo setNodeCodeSize(int nodeCodeSize, int timeout, int retry);

    /**
     * IC̎s\ǂ̃`FbNs܂
     * <p>
     * @throws FelicaException
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfo checkOnlineAccess();

    /**
     * selectŎgp^CAEglݒ肵܂B
     *
     * @param timeout ݒ肷^CAEgl(~b)
     * @throws FelicaException <code>Felica</code> gpĂAvƁÃ݂ReLXg̃AvԂUID/PIDقȂ.
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * </tbody> </table>
     */
    FelicaResultInfo setSelectTimeout(int timeout);
    
    /**
     * selectŎgp^CAEgl擾܂B
     *
     * @return timeout ݒ肷^CAEgl(~b)
     * @throws FelicaException <code>Felica</code> gpĂAvƁÃ݂ReLXg̃AvԂUID/PIDقȂ.
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_ACTIVATED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_UNKNOWN_ERROR}</td>
     * <td>{@link FelicaException#TYPE_REMOTE_ACCESS_FAILED}</td>
     * </tr>
     * </tbody> </table>
     */
   FelicaResultInfoInt getSelectTimeout();
    
    /**
     * ItC@\𒆒f܂B
     *
     * @throws FelicaException@f\ԂłȂꍇ
     * <p>
     * <table style="vertical-align: middle;" border="1" cellpadding="2"
     * cellspacing="2"> <tbody>
     * <tr>
     * <th style="text-align: center;"></th>
     * <th style="text-align: center;">^Cv</th>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_NOT_OPENED}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_CURRENTLY_ONLINE}</td>
     * </tr>
     * <tr>
     * <td>{@link FelicaException#ID_ILLEGAL_STATE_ERROR}</td>
     * <td>{@link FelicaException#TYPE_ACTIVATING_FALP}</td>
     * </tr>
     * </tbody> </table>
     */
	FelicaResultInfo cancelOffline();

}
